Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/ShaopTeam.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/ShaopTeam.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/ShaopTeam.java	(revision 10)
@@ -0,0 +1,93 @@
+package geniusweb.protocol.session.shaop;
+
+import java.util.Arrays;
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Comparison;
+import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
+import geniusweb.references.PartyWithProfile;
+
+/**
+ * A tuple of a SHOAP party and a COB party. Part of the settings.
+ *
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
+public class ShaopTeam implements TeamOfPartiesAndProfiles {
+	private final PartyWithProfile shaop;
+	private final PartyWithProfile cob;
+
+	/**
+	 * @param shaop {@link PartyWithProfile} participants supporting SHAOP
+	 *              behaviour. SHAOP behaviour has parameters:
+	 *              <ul>
+	 *              <li>elicitationcost: the value must be a double number
+	 *              indicating the costs of each RequestComparison action.
+	 *              <li>credit: the credit the party has to start with. The sum
+	 *              of the elicitationcost should stay below this.
+	 *              </ul>
+	 * @param cob   {@link PartyWithProfile} party, must support the COB
+	 *              behaviour. This is the cob partie that the shaop requests
+	 *              for {@link Comparison} will be forwarded to
+	 */
+	@JsonCreator
+	public ShaopTeam(@JsonProperty("shoap") PartyWithProfile shaop,
+			@JsonProperty("cob") PartyWithProfile cob) {
+		this.shaop = shaop;
+		this.cob = cob;
+	}
+
+	@Override
+	public List<PartyWithProfile> getAllParties() {
+		return Arrays.asList(shaop, cob);
+	}
+
+	@Override
+	public String toString() {
+		return "Parties[" + shaop + "," + cob + "]";
+	}
+
+	public PartyWithProfile getShaop() {
+		return shaop;
+	}
+
+	public PartyWithProfile getCob() {
+		return cob;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((cob == null) ? 0 : cob.hashCode());
+		result = prime * result + ((shaop == null) ? 0 : shaop.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		ShaopTeam other = (ShaopTeam) obj;
+		if (cob == null) {
+			if (other.cob != null)
+				return false;
+		} else if (!cob.equals(other.cob))
+			return false;
+		if (shaop == null) {
+			if (other.shaop != null)
+				return false;
+		} else if (!shaop.equals(other.shaop))
+			return false;
+		return true;
+	}
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 10)
@@ -81,6 +81,8 @@
 			long now = System.currentTimeMillis();
 			if (sessionstate.isFinal(now)) {
+				// List<TeamOfPartiesAndProfiles> participants =
+				// sessionstate.getSettings().getParticipants()
 				SessionResult result = new SessionResult(
-						sessionstate.getSettings().getParticipants(),
+						sessionstate.getSettings().getAllParties(),
 						sessionstate.getAgreement(), sessionstate.getError());
 				state = state.with(result);
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 10)
@@ -1,4 +1,6 @@
 package geniusweb.protocol.tournament.allpermutations;
 
+import java.net.URI;
+import java.net.URISyntaxException;
 import java.util.Collections;
 import java.util.List;
@@ -7,7 +9,14 @@
 import com.fasterxml.jackson.annotation.JsonProperty;
 
+import geniusweb.profile.Profile;
 import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
+import geniusweb.protocol.session.saop.SAOPSettings;
+import geniusweb.protocol.session.saop.SaopPartyWithProfile;
+import geniusweb.protocol.session.shaop.SHAOPSettings;
+import geniusweb.protocol.session.shaop.ShaopTeam;
 import geniusweb.protocol.tournament.TournamentProtocol;
 import geniusweb.protocol.tournament.TournamentSettings;
+import geniusweb.references.Parameters;
 import geniusweb.references.PartyRef;
 import geniusweb.references.PartyWithParameters;
@@ -30,10 +39,32 @@
  * Takes a number of parties and profiles and makes all permutations of them
  * with the given number of parties and profiles. All profiles must be in the
- * same domain. All sessions are based on the given sessionsettings (can be any
- * session protocol). The parties for each tournament session are added to this
- * basic sessionsettings.
- *
+ * same domain.
+ * <p>
+ * All sessions are based on the given {@link SessionSettings} (can be
+ * {@link SAOPSettings} or {@link SHAOPSettings}). The parties for each
+ * tournament session are added to this basic sessionsettings. sessionsettings
+ * contains basically all the normal run-sessionsettings. This is used as a
+ * "template" for all sessions of the tournament. You can put any use any
+ * session setting here, and each session will be run according to the protocol
+ * you select here.
+ * 
+ * The participants list usually is empty. The AllPermutationsProtocol adds the
+ * the required parties to this list. So if you provide a non-empty list here,
+ * then these parties would be present in every session in the tournament.
+ * <p>
+ * If the tournament is used with a SHAOP sessionsettings, a number of rules are
+ * used to generate the COB party from the settings.
+ * 
+ * The COB party is assumed to be the comparebids-1.0.0 party on the same server
+ * as the party you provide. So if you provide http://server/../party1-1.2.3
+ * then the cob party will be assumed to be at
+ * http://server/../comparebids-1.0.0. The provided parties that you provide are
+ * the SHAOP parties (you can also use SAOP parties). The provided profile is
+ * also given to the SHAOP party. Be aware that you typically need a parameter
+ * like partial=10. The COB party gets the profile as specified, but without the
+ * query part. The COB and SHAOP party are thus a fixed pair.
  */
 public class AllPermutationsSettings implements TournamentSettings {
+
 	private final List<PartyWithParameters> parties;
 	private final List<ProfileRef> profiles;
@@ -49,5 +80,6 @@
 	 *                          we use PermutationsWithoutReturn to create the
 	 *                          parties.
-	 * @param profiles
+	 * @param profiles          list of available {@link Profile}s to be
+	 *                          permutated over the parties
 	 * @param partiesPerSession number of parties per session, must be at least
 	 *                          2.
@@ -97,5 +129,5 @@
 	 */
 	public ImmutableList<SessionSettings> permutations() {
-		ImmutableList<ImmutableList<PartyWithProfile>> partylistlist;
+		ImmutableList<ImmutableList<TeamOfPartiesAndProfiles>> partylistlist;
 		ImmutableList<PartyWithParameters> partieslist = new FixedList<PartyWithParameters>(
 				parties);
@@ -166,7 +198,7 @@
 	 */
 	private SessionSettings createSetting(
-			ImmutableList<PartyWithProfile> partyproflist) {
+			ImmutableList<TeamOfPartiesAndProfiles> partyproflist) {
 		SessionSettings settings = sessionsettings;
-		for (PartyWithProfile partyprof : partyproflist) {
+		for (TeamOfPartiesAndProfiles partyprof : partyproflist) {
 			settings = settings.with(partyprof);
 		}
@@ -181,9 +213,9 @@
 	 * @param drawPartyWithPutback if parties can be drawn multiple times
 	 * @return list of sessionsets where each sessionset contains settings for a
-	 *         session: a list with {@link PartyWithProfile}s. The sessionsets
-	 *         are made by making all combinations of parties and profiles.
-	 *         Profiles are drawn with replace.
-	 */
-	private ImmutableList<ImmutableList<PartyWithProfile>> getParticipants(
+	 *         session: a list with {@link TeamOfPartiesAndProfiles}s. The
+	 *         sessionsets are made by making all combinations of parties and
+	 *         profiles. Profiles are drawn with replace.
+	 */
+	private ImmutableList<ImmutableList<TeamOfPartiesAndProfiles>> getParticipants(
 			ImmutableList<PartyWithParameters> parties,
 			ImmutableList<ProfileRef> profiles, int n,
@@ -205,6 +237,6 @@
 				partiesPermutations, profilesPermutations);
 
-		return new MapList<Tuple<ImmutableList<PartyWithParameters>, ImmutableList<ProfileRef>>, ImmutableList<PartyWithProfile>>(
-				tuple -> partyprofilelist(tuple), tuples);
+		return new MapList<Tuple<ImmutableList<PartyWithParameters>, ImmutableList<ProfileRef>>, ImmutableList<TeamOfPartiesAndProfiles>>(
+				tuple -> teamlist(tuple), tuples);
 	}
 
@@ -213,20 +245,60 @@
 	 * @param tuple a tuple with (1) ImmutableList<PartyRef> (2)
 	 *              ImmutableList<ProfileRef>
-	 * @return list of PartyWithProfile, each picked from the two lists in
-	 *         order.
-	 */
-	private ImmutableList<PartyWithProfile> partyprofilelist(
+	 * @return list of TeamOfPartiesAndProfiles, each picked from the two lists
+	 *         in order.
+	 */
+	private ImmutableList<TeamOfPartiesAndProfiles> teamlist(
 			Tuple<ImmutableList<PartyWithParameters>, ImmutableList<ProfileRef>> tuple) {
-		Function2<PartyWithParameters, ProfileRef, PartyWithProfile> //
-		makeparty = new Function2<PartyWithParameters, ProfileRef, PartyWithProfile>() {
+		Function2<PartyWithParameters, ProfileRef, TeamOfPartiesAndProfiles> //
+		makeparty = new Function2<PartyWithParameters, ProfileRef, TeamOfPartiesAndProfiles>() {
 			@Override
-			public PartyWithProfile apply(PartyWithParameters party,
+			public TeamOfPartiesAndProfiles apply(PartyWithParameters party,
 					ProfileRef profile) {
-				return new PartyWithProfile(party, profile);
+				if (sessionsettings instanceof SAOPSettings)
+					return new SaopPartyWithProfile(party, profile);
+				else if (sessionsettings instanceof SHAOPSettings) {
+					return new ShaopTeam(new PartyWithProfile(party, profile),
+							makeCob(party.getPartyRef(), profile));
+				} else
+					throw new IllegalArgumentException(
+							"Unknown/unsupported protocol "
+									+ sessionsettings.getClass());
 			}
+
 		};
-		return new MapThreadList<PartyWithProfile, PartyWithParameters, ProfileRef>(
+		return new MapThreadList<TeamOfPartiesAndProfiles, PartyWithParameters, ProfileRef>(
 				makeparty, tuple.get1(), tuple.get2());
 	}
 
+	/**
+	 * Extract the raw URL, without the part after the question mark
+	 * 
+	 * @param party   a party reference (for another party)
+	 * @param profile a profile that may have a filter like "?partial=XX"
+	 * @return profile without the filter and with a cob party on the same
+	 *         machine. IT IS ASSUMED that there will the default
+	 *         "comparebids-1.0.0" party on the same machine as where the other
+	 *         party is
+	 */
+	protected static PartyWithProfile makeCob(PartyRef party,
+			ProfileRef profile) {
+		try {
+			URI profileuri = profile.getURI();
+			URI partyuri = party.getURI();
+			ProfileRef cobprof = new ProfileRef(profileuri.getScheme() + "://"
+					+ profileuri.getAuthority() + profileuri.getPath());
+			String partypath = partyuri.getPath();
+			partypath = partypath.substring(0, partypath.lastIndexOf('/'));
+			PartyWithParameters cobparty = new PartyWithParameters(new PartyRef(
+					partyuri.getScheme() + "://" + partyuri.getAuthority()
+							+ partypath + "/comparebids-1.0.0"),
+					new Parameters());
+			return new PartyWithProfile(cobparty, cobprof);
+
+		} catch (URISyntaxException e) {
+			throw new IllegalArgumentException(
+					"Failed making cob party with profile " + profile, e);
+		}
+	}
+
 }
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java	(revision 10)
@@ -55,5 +55,5 @@
 	 */
 	public AllPermutationsState with(SessionResult result) {
-		if (!getNextSettings().getParticipants()
+		if (!getNextSettings().getAllParties()
 				.equals(result.getParticipants())) {
 			throw new IllegalArgumentException("Inconsistent session result");
Index: /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java	(revision 9)
+++ /protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java	(revision 10)
@@ -29,4 +29,5 @@
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.protocol.session.saop.SAOPSettings;
+import geniusweb.protocol.session.saop.SaopPartyWithProfile;
 import geniusweb.references.Parameters;
 import geniusweb.references.PartyRef;
@@ -39,4 +40,5 @@
 	private final ObjectMapper jackson = new ObjectMapper();
 	private DefaultSessionState1 state1, state1a, stateA, stateE, stateF;
+	// The 1 is because we are testing an instance, not the abstract class
 	private String state1string = "{\"DefaultSessionState1\":{\"actions\":[],\"progress\":{\"time\":{\"duration\":1000,\"start\":1000}},\"settings\":{\"SAOPSettings\":{\"participants\":[{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"profile1\"},{\"party\":{\"partyref\":\"party2\",\"parameters\":{}},\"profile\":\"profile2\"}],\"deadline\":{\"deadlinetime\":{\"durationms\":1000}}}},\"error\":null,\"partyprofiles\":{\"party1\":{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"profile1\"}}}}";
 	private ProgressTime progr;
@@ -58,7 +60,7 @@
 				new PartyRef("party2"), new Parameters());
 		ProfileRef profile2 = new ProfileRef("profile2");
-		List<PartyWithProfile> participants = Arrays.asList(
-				new PartyWithProfile(party1ref, profile1),
-				new PartyWithProfile(party2ref, profile2));
+		List<SaopPartyWithProfile> participants = Arrays.asList(
+				new SaopPartyWithProfile(party1ref, profile1),
+				new SaopPartyWithProfile(party2ref, profile2));
 		SessionSettings settings = new SAOPSettings(participants, deadline);
 		ProtocolException e = new ProtocolException("test protocol error",
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java	(revision 9)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPSettingsTest.java	(revision 10)
@@ -23,5 +23,4 @@
 import geniusweb.references.PartyRef;
 import geniusweb.references.PartyWithParameters;
-import geniusweb.references.PartyWithProfile;
 import geniusweb.references.ProfileRef;
 import tudelft.utilities.junit.GeneralTests;
@@ -30,10 +29,10 @@
 public class SAOPSettingsTest extends GeneralTests<SAOPSettings> {
 
-	private PartyWithProfile partyprof1 = mock(PartyWithProfile.class);
-	private PartyWithProfile partyprof2 = mock(PartyWithProfile.class);
-	private PartyWithProfile partyprof3 = mock(PartyWithProfile.class);
-	private List<PartyWithProfile> participants2 = Arrays.asList(partyprof1,
+	private SaopPartyWithProfile partyprof1 = mock(SaopPartyWithProfile.class);
+	private SaopPartyWithProfile partyprof2 = mock(SaopPartyWithProfile.class);
+	private SaopPartyWithProfile partyprof3 = mock(SaopPartyWithProfile.class);
+	private List<SaopPartyWithProfile> participants2 = Arrays.asList(partyprof1,
 			partyprof2);
-	private List<PartyWithProfile> participants3 = Arrays.asList(partyprof1,
+	private List<SaopPartyWithProfile> participants3 = Arrays.asList(partyprof1,
 			partyprof2, partyprof3);
 
@@ -67,9 +66,9 @@
 				new PartyRef("http://party2"), new Parameters());
 		ProfileRef profile2 = new ProfileRef("http://profile2");
-		PartyWithProfile partywithprof1 = new PartyWithProfile(party1,
+		SaopPartyWithProfile partywithprof1 = new SaopPartyWithProfile(party1,
 				profile1);
-		PartyWithProfile partywithprof2 = new PartyWithProfile(party2,
+		SaopPartyWithProfile partywithprof2 = new SaopPartyWithProfile(party2,
 				profile2);
-		List<PartyWithProfile> participants = Arrays.asList(partywithprof1,
+		List<SaopPartyWithProfile> participants = Arrays.asList(partywithprof1,
 				partywithprof2);
 
@@ -141,5 +140,5 @@
 		SAOPSettings saop = new SAOPSettings(participants2, deadline);
 		SessionSettings saop2 = saop.with(partyprof3);
-		assertEquals(3, saop2.getParticipants().size());
+		assertEquals(3, saop2.getTeams().size());
 	}
 
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 9)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 10)
@@ -27,6 +27,6 @@
 import geniusweb.progress.ProgressTime;
 import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.session.SessionSettings;
 import tudelft.utilities.junit.GeneralTests;
@@ -220,22 +220,17 @@
 	}
 
-	@Test
+	@Test(expected = IllegalArgumentException.class)
 	public void withWrongActionTest() {
 		// wrong because action has actor null which does not match party1
 		SAOPState state = state1.with(party1, action);
-		assertEquals(1, state.getActions().size());
-		assertEquals(action, state.getActions().get(0));
-		assertTrue(state.isFinal(NOW));
-		assertEquals(
-				"geniusweb.protocol.ProtocolException: party1:act contains wrong credentials: act1",
-				state.getError().toString());
-	}
-
-	@Test
+//		assertEquals(1, state.getActions().size());
+//		assertEquals(action, state.getActions().get(0));
+//		assertTrue(state.isFinal(NOW));
+	}
+
+	@Test(expected = IllegalArgumentException.class)
 	public void withActionTest() {
 		when(action.getActor()).thenReturn(party1);
-		SAOPState state = state1.with(party1, action);
-		assertEquals(1, state.getActions().size());
-		assertEquals(action, state.getActions().get(0));
+		state1.with(party1, action);
 	}
 
@@ -265,15 +260,11 @@
 	}
 
-	@Test
+	@Test(expected = IllegalArgumentException.class)
 	public void RefuseImmediateAccept() {
 		Accept nullaccept = new Accept(party1, null);
 		SAOPState state = state1.with(party1, nullaccept);
-		assertTrue(state.isFinal(NOW));
-		assertEquals(
-				"geniusweb.protocol.ProtocolException: party1:Accept without a recent offer",
-				state.getError().toString());
-	}
-
-	@Test
+	}
+
+	@Test(expected = IllegalArgumentException.class)
 	public void RefuseNotMyTurn() {
 		List<Action> actions = Arrays.asList(offer1);
@@ -281,12 +272,12 @@
 				settings, null, null);
 
-		state = state.with(party1, offer1);
-		assertTrue(state.isFinal(NOW));
-		assertEquals(
-				"geniusweb.protocol.ProtocolException: party1:Party does not have the turn ",
-				state.getError().toString());
-	}
-
-	@Test
+		state.with(party1, offer1);
+//		assertTrue(state.isFinal(NOW));
+//		assertEquals(
+//				"geniusweb.protocol.ProtocolException: party1:Party does not have the turn ",
+//				state.getError().toString());
+	}
+
+	@Test(expected = IllegalArgumentException.class)
 	public void RefuseNullAccept() {
 		List<Action> actions = Arrays.asList(offer1);
@@ -297,9 +288,7 @@
 		state = state.with(party2, nullaccept);
 		assertTrue(state.isFinal(NOW));
-		assertTrue(state.getError().toString().matches(
-				".*party2.*Party accepts a bid differing from the last offer.*"));
-	}
-
-	@Test
+	}
+
+	@Test(expected = IllegalArgumentException.class)
 	public void RefuseNullAction() {
 		List<Action> actions = Arrays.asList(offer1);
@@ -308,7 +297,4 @@
 
 		state = state.with(party2, null);
-		assertEquals(
-				"geniusweb.protocol.ProtocolException: party2:action is null",
-				state.getError().toString());
 	}
 
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java	(revision 9)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java	(revision 10)
@@ -20,4 +20,5 @@
 import java.util.List;
 import java.util.Map;
+import java.util.stream.Collectors;
 
 import org.junit.Test;
@@ -39,7 +40,8 @@
 import geniusweb.progress.Progress;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
 import geniusweb.references.Parameters;
 import geniusweb.references.PartyRef;
@@ -73,6 +75,6 @@
 	private final PartyRef party2ref = mock(PartyRef.class);
 	private final SAOPSettings settings = mock(SAOPSettings.class);
-	private final PartyWithProfile party1 = mock(PartyWithProfile.class);
-	private final PartyWithProfile party2 = mock(PartyWithProfile.class);
+	private final SaopPartyWithProfile team1 = mock(SaopPartyWithProfile.class);
+	private final SaopPartyWithProfile team2 = mock(SaopPartyWithProfile.class);
 	private SAOP saop;
 	private ProtocolToPartyConnFactory factory;
@@ -80,5 +82,5 @@
 	private ProtocolToPartyConn conn1 = mock(ProtocolToPartyConn.class),
 			conn2 = mock(ProtocolToPartyConn.class);
-	private Map<PartyId, PartyWithProfile> partyprofiles;
+	private Map<PartyId, SaopPartyWithProfile> partyprofiles;
 	private Progress progress = mock(Progress.class);
 	private ProfileRef profile1;
@@ -101,17 +103,20 @@
 			throws URISyntaxException, IOException, NoResourcesNowException {
 		SAOP = new ProtocolRef("SAOP");
-		when(party1.getParty()).thenReturn(partywithparam1);
-		when(party2.getParty()).thenReturn(partywithparam2);
+		when(team1.getParty()).thenReturn(partywithparam1);
+		when(team2.getParty()).thenReturn(partywithparam2);
+		when(team1.getAllParties()).thenReturn(Arrays.asList(team1));
+		when(team2.getAllParties()).thenReturn(Arrays.asList(team2));
 
 		partyprofiles = new HashMap<>();
-		partyprofiles.put(PARTY1ID, party1);
-		partyprofiles.put(PARTY2ID, party2);
+		partyprofiles.put(PARTY1ID, team1);
+		partyprofiles.put(PARTY2ID, team2);
 
 		when(deadlinetime.getDuration()).thenReturn(1000l);
 
-		List<PartyWithProfile> participants = new ArrayList<>();
-		participants.add(party1);
-		participants.add(party2);
-		when(settings.getParticipants()).thenReturn(participants);
+		List<TeamOfPartiesAndProfiles> teams = new ArrayList<>();
+		teams.add(team1);
+		teams.add(team2);
+		when(settings.getTeams()).thenReturn(teams);
+		when(settings.getAllParties()).thenReturn(Arrays.asList(team1, team2));
 		when(settings.getDeadline()).thenReturn(deadlinetime);
 
@@ -126,7 +131,7 @@
 
 		profile1 = mock(ProfileRef.class);
-		when(party1.getProfile()).thenReturn(profile1);
+		when(team1.getProfile()).thenReturn(profile1);
 		profile2 = mock(ProfileRef.class);
-		when(party2.getProfile()).thenReturn(profile2);
+		when(team2.getProfile()).thenReturn(profile2);
 
 		mockState(connectedstate, "connected state");
@@ -157,5 +162,7 @@
 		when(state.getSettings()).thenReturn(settings);
 		when(state.getConnections()).thenReturn(connectionswithparties);
-		when(state.getPartyProfiles()).thenReturn(partyprofiles);
+		when(state.getPartyProfiles())
+				.thenReturn(partyprofiles.entrySet().stream().collect(
+						Collectors.toMap(e -> e.getKey(), e -> e.getValue())));
 		when(state.getProgress()).thenReturn(progress);
 		when(state.with(any(ProtocolToPartyConn.class),
Index: /protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java	(revision 10)
+++ /protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java	(revision 10)
@@ -0,0 +1,110 @@
+package geniusweb.protocol.session.saop;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyRef;
+import geniusweb.references.PartyWithParameters;
+import geniusweb.references.ProfileRef;
+import tudelft.utilities.junit.GeneralTests;
+
+public class SaopPartyWithProfileTest
+		extends GeneralTests<SaopPartyWithProfile> {
+
+	private PartyRef party1, party1a, party2, party3;
+	private ProfileRef profile1, profile2;
+	private SaopPartyWithProfile partyprof1, partyprof1a, partyprof2,
+			partyprof3, partyprof4;
+	private final String serialized = "{\"party\":{\"partyref\":\"ws:party1\",\"parameters\":{}},\"profile\":\"ws:profile1\"}";
+
+	@Before
+	public void before() throws URISyntaxException {
+		party1 = new PartyRef(new URI("ws:party1"));
+		party1a = new PartyRef(new URI("ws:party1"));
+		party2 = new PartyRef(new URI("ws:party2"));
+		party3 = new PartyRef(new URI("http:party3"));
+
+		profile1 = new ProfileRef(new URI("ws:profile1"));
+		profile2 = new ProfileRef(new URI("ws:profile2"));
+
+		Parameters settings1 = new Parameters();
+		Parameters settings2 = new Parameters();
+		settings2.put("a", 1);
+
+		PartyWithParameters party1withparams1 = new PartyWithParameters(party1,
+				settings1);
+		PartyWithParameters party1withparams2 = new PartyWithParameters(party1,
+				settings2);
+		PartyWithParameters party2withparams1 = new PartyWithParameters(party2,
+				settings1);
+
+		partyprof1 = new SaopPartyWithProfile(party1withparams1, profile1);
+		partyprof1a = new SaopPartyWithProfile(party1withparams1, profile1);
+		partyprof2 = new SaopPartyWithProfile(party2withparams1, profile1);
+		partyprof3 = new SaopPartyWithProfile(party1withparams1, profile2);
+		partyprof4 = new SaopPartyWithProfile(party1withparams2, profile1);
+
+	}
+
+	@Override
+	public List<List<SaopPartyWithProfile>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(partyprof1, partyprof1a),
+				Arrays.asList(partyprof2), Arrays.asList(partyprof3),
+				Arrays.asList(partyprof4));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"PartyWithProfile.PartyRef.ws:party1.,ProfileRef.ws:profile1.*",
+				"PartyWithProfile.PartyRef.ws:party2.,ProfileRef.ws:profile1.*",
+				"PartyWithProfile.PartyRef.ws:party1.,ProfileRef.ws:profile2.*",
+				"PartyWithProfile.PartyRef.ws:party1.\\{a=1\\},ProfileRef.ws:profile1.*");
+	}
+
+	@Test
+	public void smokeTest() throws URISyntaxException {
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void nullTest() throws URISyntaxException {
+		new SaopPartyWithProfile((PartyWithParameters) null, (ProfileRef) null);
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(partyprof1);
+		System.out.println(json);
+		assertEquals(serialized, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		// always used as part of bigger class, do not include class name
+		// and therfore can not serialize as TeamOfPartiesAndProfiles
+		TeamOfPartiesAndProfiles p = jackson.readValue(serialized,
+				SaopPartyWithProfile.class);
+		System.out.println(p);
+		assertEquals(partyprof1, p);
+	}
+
+}
